-- Euphoria Assembly Opcodes by Jeffrey Fielding (JJProg@cyberbury.net)
global constant VAL = 1,
                VAR = 2
global constant OPCODES = {{"setrv",#0,{VAL}},
{"mov",#1,{VAL,VAL}},
{"mov",#2,{VAL,VAR}},
{"movdi",#3,{VAL,VAL,VAL}},
{"movdi",#4,{VAL,VAR,VAL}},
{"movdi",#5,{VAL,VAL,VAR}},
{"movdi",#6,{VAL,VAR,VAR}},
{"movsi",#7,{VAL,VAL,VAL}},
{"movsi",#8,{VAL,VAR,VAL}},
{"movsi",#9,{VAL,VAL,VAR}},
{"movsi",#A,{VAL,VAR,VAR}},
{"add",#B,{VAL,VAL}},
{"add",#C,{VAL,VAR}},
{"sub",#D,{VAL,VAL}},
{"sub",#E,{VAL,VAR}},
{"mul",#F,{VAL,VAL}},
{"mul",#10,{VAL,VAR}},
{"div",#11,{VAL,VAL}},
{"div",#12,{VAL,VAR}},
{"and",#13,{VAL,VAL}},
{"and",#14,{VAL,VAR}},
{"or",#15,{VAL,VAL}},
{"or",#16,{VAL,VAR}},
{"xor",#17,{VAL,VAL}},
{"xor",#18,{VAL,VAR}},
{"not",#19,{VAL}},
{"movlen",#1A,{VAL,VAL}},
{"movlen",#1B,{VAL,VAR}},
{"repeat",#1C,{VAL,VAL}},
{"repeat",#1D,{VAL,VAR}},
{"append",#1E,{VAL,VAL}},
{"append",#1F,{VAL,VAR}},
{"prepend",#20,{VAL,VAL}},
{"prepend",#21,{VAL,VAR}},
{"concen",#22,{VAL,VAL}},
{"concen",#23,{VAL,VAR}},
{"andbits",#24,{VAL,VAL}},
{"andbits",#25,{VAL,VAR}},
{"orbits",#26,{VAL,VAL}},
{"orbits",#27,{VAL,VAR}},
{"xorbits",#28,{VAL,VAL}},
{"xorbits",#29,{VAL,VAR}},
{"notbits",#2A,{VAL}},
{"floor",#2B,{VAL}},
{"sqrt",#2C,{VAL}},
{"remainder",#2D,{VAL,VAL}},
{"remainder",#2E,{VAL,VAR}},
{"rand",#2F,{VAL,VAL}},
{"rand",#30,{VAL,VAR}},
{"sin",#31,{VAL}},
{"arcsin",#32,{VAL}},
{"cos",#33,{VAL}},
{"arccos",#34,{VAL}},
{"tan",#35,{VAL}},
{"arctan",#36,{VAL}},
{"log",#37,{VAL}},
{"power",#38,{VAL,VAL}},
{"power",#39,{VAL,VAR}},
{"ce",#3A,{VAL,VAL}},
{"ce",#3B,{VAR,VAL}},
{"ce",#3C,{VAL,VAR}},
{"ce",#3D,{VAR,VAR}},
{"cne",#3E,{VAL,VAL}},
{"cne",#3F,{VAR,VAL}},
{"cne",#40,{VAL,VAR}},
{"cne",#41,{VAR,VAR}},
{"cl",#42,{VAL,VAL}},
{"cl",#43,{VAR,VAL}},
{"cl",#44,{VAL,VAR}},
{"cl",#45,{VAR,VAR}},
{"cg",#46,{VAL,VAL}},
{"cg",#47,{VAR,VAL}},
{"cg",#48,{VAL,VAR}},
{"cg",#49,{VAR,VAR}},
{"cle",#4A,{VAL,VAL}},
{"cle",#4B,{VAR,VAL}},
{"cle",#4C,{VAL,VAR}},
{"cle",#4D,{VAR,VAR}},
{"cge",#4E,{VAL,VAL}},
{"cge",#4F,{VAR,VAL}},
{"cge",#50,{VAL,VAR}},
{"cge",#51,{VAR,VAR}},
{"cmp",#52,{VAL,VAL}},
{"cmp",#53,{VAR,VAL}},
{"cmp",#54,{VAL,VAR}},
{"cmp",#55,{VAR,VAR}},
{"equ",#56,{VAL,VAL}},
{"equ",#57,{VAR,VAL}},
{"equ",#58,{VAL,VAR}},
{"equ",#59,{VAR,VAR}},
{"ret",#5A,{}},
{"call",#5B,{VAL}},
{"call",#5C,{VAR}},
{"jmp",#5D,{VAL}},
{"jmp",#5E,{VAR}},
{"cjmp",#5F,{VAL,VAL}},
{"cjmp",#60,{VAR,VAL}},
{"cjmp",#61,{VAL,VAR}},
{"cjmp",#62,{VAR,VAR}},
{"end",#63,{}},
{"err",#64,{VAL}},
{"err",#65,{VAR}},
{"push",#66,{VAL}},
{"push",#67,{VAR}},
{"pop",#68,{VAL}},
{"ldss",#69,{VAL}},
{"oscall",#6A,{VAL}},
{"oscall",#6B,{VAR}},
{"isinteger",#6C,{VAL}},
{"isinteger",#6D,{VAR}},
{"isatom",#6E,{VAL}},
{"isatom",#6F,{VAR}},
{"issequence",#70,{VAL}},
{"issequence",#71,{VAR}}}
