#ifndef EUOBJECT_H
#define EUOBJECT_H
#define INTEGER 1
#define ATOM 2
#define SEQUENCE 3
#include <stdio.h>
class EuObject
{
 public:
          union
          {
            long iVal;
            double aVal;
            EuObject *children;
          };
          int type;
          long size;
          long actualSize;
          EuObject();
          EuObject(EuObject *obj);
          ~EuObject();
          void movdi(EuObject *index, EuObject *val);
          void movsi(EuObject *index, EuObject *val);
          void mov(EuObject *obj);
          void fastmov(EuObject *obj);
          void add(EuObject *obj);
          void sub(EuObject *obj);
          void mul(EuObject *obj);
          void div(EuObject *obj);
          void and(EuObject *obj);
          void or(EuObject *obj);
          void xor(EuObject *obj);
          void not();
          void andbits(EuObject *obj);
          void orbits(EuObject *obj);
          void xorbits(EuObject *obj);
          void append(EuObject *obj);
          void prepend(EuObject *obj);
          void ReadValue(FILE *f);
          void movlen(EuObject *obj);
          void repeat(EuObject *n);
          void concen(EuObject *obj);
          void isinteger(EuObject *obj);
          void isatom(EuObject *obj);
          void issequence(EuObject *obj);
          void Floor();
          void Sqrt();
          void Sin();
          void arcsin();
          void Cos();
          void arccos();
          void Tan();
          void arctan();
          void Log();
          void remainder(EuObject *obj);
          void rand(EuObject *obj);
          void power(EuObject *obj);
          void ce(EuObject *obj);
          void cne(EuObject *obj);
          void cl(EuObject *obj);
          void cle(EuObject *obj);
          void cg(EuObject *obj);
          void cge(EuObject *obj);
          void cmp(EuObject *obj);
          void equ(EuObject *obj);
};
#endif
