#include "common.h"
#include "calstack.h"
#include <time.h>
void ret()
{
   CallStack *s = callstack->prev;
   ip = callstack->ipv;
   rp = callstack->rpv;
   delete callstack;
   callstack = s;
}
void call(long rpv)
{
   CallStack *s;
   s = new CallStack();
   s->ipv = ip+1;
   s->rpv = rp;
   s->prev = callstack;
   callstack = s;
   rp = rpv;
   ip = 0;
}
void jmp(long label)
{
   ip = label-1;
}
void cjmp(long label, EuObject *obj)
{
   ip++;
   //printf("%d %d\n",rv,obj);
   if (obj->type == INTEGER)
   {
      if (obj->iVal != 0)
         ip = label-1;
   } else if (obj->type == ATOM)
   {
      if (obj->aVal != 0)
         ip = label-1;
   }
}
void end()
{
   exit(0);
}
void err(EuObject *obj)
{
   printf("Error: %d\n",obj->iVal);
   end();
}
Stack *stack = 0;
long stackSize;
void Stack::push(EuObject *obj)
{
   prev = stack;
   stack = this;
   stackSize++;
   val = new EuObject();
   val->mov(obj);
}
void Stack::pop(EuObject *obj)
{
   obj->mov(val);
   stack = prev;
   stackSize--;
   delete val;
   delete this;
}
void Push(EuObject *obj)
{
   Stack *s = new Stack();
   s->push(obj);
}
void Pop(EuObject *obj)
{
   stack->pop(obj);
}
void ldss(EuObject *obj)
{
   if (obj->type == SEQUENCE)
   {
      if (obj->children)
         delete [] obj->children;
   }
   obj->type = INTEGER;
   obj->iVal = stackSize;
}
void oscall(EuObject *obj)
{
   EuObject *param;
   if (obj->iVal == 1)
   {
      param = new EuObject();
      Pop(param);
      if (param->type == INTEGER)
      {
         printf("%d\n",param->iVal);
      } else if (param->type == ATOM)
      {
         printf("%f\n",param->aVal);
      } else {
         for (long i = 0; i < param->size; i++)
             printf("%c",(char)param->children[i].iVal);
         printf("\n");
      }
   } else if (obj->iVal == 2)
   {
      param = new EuObject();
      Pop(param);
      param = &vars[param->iVal-1];
      if (param->type == SEQUENCE)
      {
         if (param->children)
            delete [] param->children;
      }
      param->type = INTEGER;
      param->iVal = time(0);
   }
}
